/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 08.05.2005                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/


// weight and quantize tables
const int16_t WQ_88[9*64] = {
	0x4000, 0x7d8a, 0x7642, 0x7332, 0x7000, 0x6cdb, 0x61f8, 0x5c48,
	0x7d8a, 0x7b21, 0x73fc, 0x70fc, 0x6dd9, 0x6ac3, 0x6016, 0x5a82,
	0x7642, 0x73fc, 0x6d41, 0x6a6e, 0x6779, 0x6492, 0x5a82, 0x5542,
	0x7332, 0x70fc, 0x6a6e, 0x67ad, 0x64cc, 0x61f8, 0x582b, 0x530d,
	0x7000, 0x6dd9, 0x6779, 0x64cc, 0x6200, 0x5f40, 0x55b9, 0x50bf,
	0x6cdb, 0x6ac3, 0x6492, 0x61f8, 0x5f40, 0x5c93, 0x5350, 0x4e7b,
	0x61f8, 0x6016, 0x5a82, 0x582b, 0x55b9, 0x5350, 0x4afb, 0x46a1,
	0x5c48, 0x5a82, 0x5542, 0x530d, 0x50bf, 0x4e7b, 0x46a1, 0x4288,

	0x4000, 0x7d8a, 0x7642, 0x7332, 0x7000, 0x6cdb, 0x61f8, 0x5c48,
	0x7d8a, 0x7b21, 0x73fc, 0x70fc, 0x6dd9, 0x6ac3, 0x6016, 0x5a82,
	0x7642, 0x73fc, 0x6d41, 0x6a6e, 0x6779, 0x6492, 0x5a82, 0x2aa1,
	0x7332, 0x70fc, 0x6a6e, 0x67ad, 0x64cc, 0x61f8, 0x2c15, 0x2987,
	0x7000, 0x6dd9, 0x6779, 0x64cc, 0x6200, 0x2fa0, 0x2adc, 0x2860,
	0x6cdb, 0x6ac3, 0x6492, 0x61f8, 0x2fa0, 0x2e49, 0x29a8, 0x273d,
	0x61f8, 0x6016, 0x5a82, 0x2c15, 0x2adc, 0x29a8, 0x257e, 0x2351,
	0x5c48, 0x5a82, 0x2aa1, 0x2987, 0x2860, 0x273d, 0x2351, 0x2144,

	0x4000, 0x7d8a, 0x7642, 0x7332, 0x7000, 0x6cdb, 0x30fc, 0x2e24,
	0x7d8a, 0x7b21, 0x73fc, 0x70fc, 0x6dd9, 0x3562, 0x300b, 0x2d41,
	0x7642, 0x73fc, 0x6d41, 0x6a6e, 0x33bd, 0x3249, 0x2d41, 0x2aa1,
	0x7332, 0x70fc, 0x6a6e, 0x33d6, 0x3266, 0x30fc, 0x2c15, 0x2987,
	0x7000, 0x6dd9, 0x33bd, 0x3266, 0x3100, 0x2fa0, 0x2adc, 0x2860,
	0x6cdb, 0x3562, 0x3249, 0x30fc, 0x2fa0, 0x2e49, 0x29a8, 0x273d,
	0x30fc, 0x300b, 0x2d41, 0x2c15, 0x2adc, 0x29a8, 0x257e, 0x2351,
	0x2e24, 0x2d41, 0x2aa1, 0x2987, 0x2860, 0x273d, 0x2351, 0x2144,

	0x4000, 0x7d8a, 0x7642, 0x3999, 0x3800, 0x366d, 0x30fc, 0x2e24,
	0x7d8a, 0x7b21, 0x39fe, 0x387e, 0x36ed, 0x3562, 0x300b, 0x2d41,
	0x7642, 0x39fe, 0x36a1, 0x3537, 0x33bd, 0x3249, 0x2d41, 0x1551,
	0x3999, 0x387e, 0x3537, 0x33d6, 0x3266, 0x30fc, 0x160b, 0x14c3,
	0x3800, 0x36ed, 0x33bd, 0x3266, 0x3100, 0x17d0, 0x156e, 0x1430,
	0x366d, 0x3562, 0x3249, 0x30fc, 0x17d0, 0x1725, 0x14d4, 0x139f,
	0x30fc, 0x300b, 0x2d41, 0x160b, 0x156e, 0x14d4, 0x12bf, 0x11a8,
	0x2e24, 0x2d41, 0x1551, 0x14c3, 0x1430, 0x139f, 0x11a8, 0x10a2,

	0x4000, 0x3ec5, 0x3b21, 0x3999, 0x3800, 0x366d, 0x187e, 0x1712,
	0x3ec5, 0x3d90, 0x39fe, 0x387e, 0x36ed, 0x1ab1, 0x1805, 0x16a1,
	0x3b21, 0x39fe, 0x36a1, 0x3537, 0x19de, 0x1924, 0x16a1, 0x1551,
	0x3999, 0x387e, 0x3537, 0x19eb, 0x1933, 0x187e, 0x160b, 0x14c3,
	0x3800, 0x36ed, 0x19de, 0x1933, 0x1880, 0x17d0, 0x156e, 0x1430,
	0x366d, 0x1ab1, 0x1924, 0x187e, 0x17d0, 0x1725, 0x14d4, 0x139f,
	0x187e, 0x1805, 0x16a1, 0x160b, 0x156e, 0x14d4, 0x12bf, 0x11a8,
	0x1712, 0x16a1, 0x1551, 0x14c3, 0x1430, 0x139f, 0x11a8, 0x10a2,

	0x4000, 0x3ec5, 0x3b21, 0x1ccd, 0x1c00, 0x1b37, 0x187e, 0x1712,
	0x3ec5, 0x3d90, 0x1cff, 0x1c3f, 0x1b76, 0x1ab1, 0x1805, 0x16a1,
	0x3b21, 0x1cff, 0x1b50, 0x1a9b, 0x19de, 0x1924, 0x16a1, 0x0aa8,
	0x1ccd, 0x1c3f, 0x1a9b, 0x19eb, 0x1933, 0x187e, 0x0b05, 0x0a62,
	0x1c00, 0x1b76, 0x19de, 0x1933, 0x1880, 0x0be8, 0x0ab7, 0x0a18,
	0x1b37, 0x1ab1, 0x1924, 0x187e, 0x0be8, 0x0b92, 0x0a6a, 0x09cf,
	0x187e, 0x1805, 0x16a1, 0x0b05, 0x0ab7, 0x0a6a, 0x095f, 0x08d4,
	0x1712, 0x16a1, 0x0aa8, 0x0a62, 0x0a18, 0x09cf, 0x08d4, 0x0851,

	0x4000, 0x1f63, 0x1d90, 0x1ccd, 0x1c00, 0x1b37, 0x0c3f, 0x0b89,
	0x1f63, 0x1ec8, 0x1cff, 0x1c3f, 0x1b76, 0x0d58, 0x0c03, 0x0b50,
	0x1d90, 0x1cff, 0x1b50, 0x1a9b, 0x0cef, 0x0c92, 0x0b50, 0x0aa8,
	0x1ccd, 0x1c3f, 0x1a9b, 0x0cf6, 0x0c9a, 0x0c3f, 0x0b05, 0x0a62,
	0x1c00, 0x1b76, 0x0cef, 0x0c9a, 0x0c40, 0x0be8, 0x0ab7, 0x0a18,
	0x1b37, 0x0d58, 0x0c92, 0x0c3f, 0x0be8, 0x0b92, 0x0a6a, 0x09cf,
	0x0c3f, 0x0c03, 0x0b50, 0x0b05, 0x0ab7, 0x0a6a, 0x095f, 0x08d4,
	0x0b89, 0x0b50, 0x0aa8, 0x0a62, 0x0a18, 0x09cf, 0x08d4, 0x0851,

	0x4000, 0x1f63, 0x1d90, 0x0e66, 0x0e00, 0x0d9b, 0x0c3f, 0x0b89,
	0x1f63, 0x1ec8, 0x0e7f, 0x0e1f, 0x0dbb, 0x0d58, 0x0c03, 0x0b50,
	0x1d90, 0x0e7f, 0x0da8, 0x0d4e, 0x0cef, 0x0c92, 0x0b50, 0x0554,
	0x0e66, 0x0e1f, 0x0d4e, 0x0cf6, 0x0c9a, 0x0c3f, 0x0583, 0x0531,
	0x0e00, 0x0dbb, 0x0cef, 0x0c9a, 0x0c40, 0x05f4, 0x055c, 0x050c,
	0x0d9b, 0x0d58, 0x0c92, 0x0c3f, 0x05f4, 0x05c9, 0x0535, 0x04e8,
	0x0c3f, 0x0c03, 0x0b50, 0x0583, 0x055c, 0x0535, 0x04b0, 0x046a,
	0x0b89, 0x0b50, 0x0554, 0x0531, 0x050c, 0x04e8, 0x046a, 0x0429,

	0x4000, 0x0fb1, 0x0ec8, 0x0e66, 0x0e00, 0x0d9b, 0x061f, 0x05c5,
	0x0fb1, 0x0f64, 0x0e7f, 0x0e1f, 0x0dbb, 0x06ac, 0x0601, 0x05a8,
	0x0ec8, 0x0e7f, 0x0da8, 0x0d4e, 0x0678, 0x0649, 0x05a8, 0x0554,
	0x0e66, 0x0e1f, 0x0d4e, 0x067b, 0x064d, 0x061f, 0x0583, 0x0531,
	0x0e00, 0x0dbb, 0x0678, 0x064d, 0x0620, 0x05f4, 0x055c, 0x050c,
	0x0d9b, 0x06ac, 0x0649, 0x061f, 0x05f4, 0x05c9, 0x0535, 0x04e8,
	0x061f, 0x0601, 0x05a8, 0x0583, 0x055c, 0x0535, 0x04b0, 0x046a,
	0x05c5, 0x05a8, 0x0554, 0x0531, 0x050c, 0x04e8, 0x046a, 0x0429
};


const int16_t WQ_248[9*64] = {
	0x4000, 0x7d8a, 0x7642, 0x7332, 0x7000, 0x6cdb, 0x61f8, 0x5c48,
	0x7642, 0x73fc, 0x6d41, 0x6a6e, 0x6779, 0x6492, 0x5a82, 0x5542,
	0x7000, 0x6dd9, 0x6779, 0x64cc, 0x6200, 0x5f40, 0x55b9, 0x50bf,
	0x61f8, 0x6016, 0x5a82, 0x582b, 0x55b9, 0x5350, 0x4afb, 0x46a1,
	0x7fff, 0x7d8a, 0x7642, 0x7332, 0x7000, 0x6cdb, 0x61f8, 0x5c48,
	0x7642, 0x73fc, 0x6d41, 0x6a6e, 0x6779, 0x6492, 0x5a82, 0x5542,
	0x7000, 0x6dd9, 0x6779, 0x64cc, 0x6200, 0x5f40, 0x55b9, 0x50bf,
	0x61f8, 0x6016, 0x5a82, 0x582b, 0x55b9, 0x5350, 0x4afb, 0x46a1,

	0x4000, 0x7d8a, 0x7642, 0x7332, 0x7000, 0x6cdb, 0x61f8, 0x2e24,
	0x7642, 0x73fc, 0x6d41, 0x6a6e, 0x6779, 0x6492, 0x2d41, 0x2aa1,
	0x7000, 0x6dd9, 0x6779, 0x64cc, 0x6200, 0x2fa0, 0x2adc, 0x2860,
	0x61f8, 0x6016, 0x5a82, 0x582b, 0x2adc, 0x29a8, 0x257e, 0x2351,
	0x7fff, 0x7d8a, 0x7642, 0x7332, 0x7000, 0x6cdb, 0x61f8, 0x2e24,
	0x7642, 0x73fc, 0x6d41, 0x6a6e, 0x6779, 0x6492, 0x2d41, 0x2aa1,
	0x7000, 0x6dd9, 0x6779, 0x64cc, 0x6200, 0x2fa0, 0x2adc, 0x2860,
	0x61f8, 0x6016, 0x5a82, 0x2c15, 0x2adc, 0x29a8, 0x257e, 0x2351,

	0x4000, 0x7d8a, 0x7642, 0x7332, 0x7000, 0x366d, 0x30fc, 0x2e24,
	0x7642, 0x73fc, 0x6d41, 0x3537, 0x33bd, 0x3249, 0x2d41, 0x2aa1,
	0x7000, 0x6dd9, 0x33bd, 0x3266, 0x3100, 0x2fa0, 0x2adc, 0x2860,
	0x61f8, 0x300b, 0x2d41, 0x2c15, 0x2adc, 0x29a8, 0x257e, 0x2351,
	0x7fff, 0x7d8a, 0x7642, 0x7332, 0x3800, 0x366d, 0x30fc, 0x2e24,
	0x7642, 0x73fc, 0x6d41, 0x3537, 0x33bd, 0x3249, 0x2d41, 0x2aa1,
	0x7000, 0x6dd9, 0x33bd, 0x3266, 0x3100, 0x2fa0, 0x2adc, 0x2860,
	0x61f8, 0x300b, 0x2d41, 0x2c15, 0x2adc, 0x29a8, 0x257e, 0x2351,

	0x4000, 0x7d8a, 0x3b21, 0x3999, 0x3800, 0x366d, 0x30fc, 0x1712,
	0x7642, 0x39fe, 0x36a1, 0x3537, 0x33bd, 0x3249, 0x16a1, 0x1551,
	0x3800, 0x36ed, 0x33bd, 0x3266, 0x3100, 0x17d0, 0x156e, 0x1430,
	0x30fc, 0x300b, 0x2d41, 0x2c15, 0x156e, 0x14d4, 0x12bf, 0x11a8,
	0x7fff, 0x7d8a, 0x3b21, 0x3999, 0x3800, 0x366d, 0x30fc, 0x1712,
	0x7642, 0x39fe, 0x36a1, 0x3537, 0x33bd, 0x3249, 0x16a1, 0x1551,
	0x3800, 0x36ed, 0x33bd, 0x3266, 0x3100, 0x17d0, 0x156e, 0x1430,
	0x30fc, 0x300b, 0x2d41, 0x160b, 0x156e, 0x14d4, 0x12bf, 0x11a8,

	0x4000, 0x3ec5, 0x3b21, 0x3999, 0x3800, 0x1b37, 0x187e, 0x1712,
	0x3b21, 0x39fe, 0x36a1, 0x1a9b, 0x19de, 0x1924, 0x16a1, 0x1551,
	0x3800, 0x36ed, 0x19de, 0x1933, 0x1880, 0x17d0, 0x156e, 0x1430,
	0x30fc, 0x1805, 0x16a1, 0x160b, 0x156e, 0x14d4, 0x12bf, 0x11a8,
	0x4000, 0x3ec5, 0x3b21, 0x3999, 0x1c00, 0x1b37, 0x187e, 0x1712,
	0x3b21, 0x39fe, 0x36a1, 0x1a9b, 0x19de, 0x1924, 0x16a1, 0x1551,
	0x3800, 0x36ed, 0x19de, 0x1933, 0x1880, 0x17d0, 0x156e, 0x1430,
	0x30fc, 0x1805, 0x16a1, 0x160b, 0x156e, 0x14d4, 0x12bf, 0x11a8,

	0x4000, 0x3ec5, 0x1d90, 0x1ccd, 0x1c00, 0x1b37, 0x187e, 0x0b89,
	0x3b21, 0x1cff, 0x1b50, 0x1a9b, 0x19de, 0x1924, 0x0b50, 0x0aa8,
	0x1c00, 0x1b76, 0x19de, 0x1933, 0x1880, 0x0be8, 0x0ab7, 0x0a18,
	0x187e, 0x1805, 0x16a1, 0x160b, 0x0ab7, 0x0a6a, 0x095f, 0x08d4,
	0x4000, 0x3ec5, 0x1d90, 0x1ccd, 0x1c00, 0x1b37, 0x187e, 0x0b89,
	0x3b21, 0x1cff, 0x1b50, 0x1a9b, 0x19de, 0x1924, 0x0b50, 0x0aa8,
	0x1c00, 0x1b76, 0x19de, 0x1933, 0x1880, 0x0be8, 0x0ab7, 0x0a18,
	0x187e, 0x1805, 0x16a1, 0x0b05, 0x0ab7, 0x0a6a, 0x095f, 0x08d4,

	0x4000, 0x1f63, 0x1d90, 0x1ccd, 0x1c00, 0x0d9b, 0x0c3f, 0x0b89,
	0x1d90, 0x1cff, 0x1b50, 0x0d4e, 0x0cef, 0x0c92, 0x0b50, 0x0aa8,
	0x1c00, 0x1b76, 0x0cef, 0x0c9a, 0x0c40, 0x0be8, 0x0ab7, 0x0a18,
	0x187e, 0x0c03, 0x0b50, 0x0b05, 0x0ab7, 0x0a6a, 0x095f, 0x08d4,
	0x2000, 0x1f63, 0x1d90, 0x1ccd, 0x0e00, 0x0d9b, 0x0c3f, 0x0b89,
	0x1d90, 0x1cff, 0x1b50, 0x0d4e, 0x0cef, 0x0c92, 0x0b50, 0x0aa8,
	0x1c00, 0x1b76, 0x0cef, 0x0c9a, 0x0c40, 0x0be8, 0x0ab7, 0x0a18,
	0x187e, 0x0c03, 0x0b50, 0x0b05, 0x0ab7, 0x0a6a, 0x095f, 0x08d4,

	0x4000, 0x1f63, 0x0ec8, 0x0e66, 0x0e00, 0x0d9b, 0x0c3f, 0x05c5,
	0x1d90, 0x0e7f, 0x0da8, 0x0d4e, 0x0cef, 0x0c92, 0x05a8, 0x0554,
	0x0e00, 0x0dbb, 0x0cef, 0x0c9a, 0x0c40, 0x05f4, 0x055c, 0x050c,
	0x0c3f, 0x0c03, 0x0b50, 0x0b05, 0x055c, 0x0535, 0x04b0, 0x046a,
	0x2000, 0x1f63, 0x0ec8, 0x0e66, 0x0e00, 0x0d9b, 0x0c3f, 0x05c5,
	0x1d90, 0x0e7f, 0x0da8, 0x0d4e, 0x0cef, 0x0c92, 0x05a8, 0x0554,
	0x0e00, 0x0dbb, 0x0cef, 0x0c9a, 0x0c40, 0x05f4, 0x055c, 0x050c,
	0x0c3f, 0x0c03, 0x0b50, 0x0583, 0x055c, 0x0535, 0x04b0, 0x046a,

	0x4000, 0x0fb1, 0x0ec8, 0x0e66, 0x0e00, 0x06ce, 0x061f, 0x05c5,
	0x0ec8, 0x0e7f, 0x0da8, 0x06a7, 0x0678, 0x0649, 0x05a8, 0x0554,
	0x0e00, 0x0dbb, 0x0678, 0x064d, 0x0620, 0x05f4, 0x055c, 0x050c,
	0x0c3f, 0x0601, 0x05a8, 0x0583, 0x055c, 0x0535, 0x04b0, 0x046a,
	0x1000, 0x0fb1, 0x0ec8, 0x0e66, 0x0700, 0x06ce, 0x061f, 0x05c5,
	0x0ec8, 0x0e7f, 0x0da8, 0x06a7, 0x0678, 0x0649, 0x05a8, 0x0554,
	0x0e00, 0x0dbb, 0x0678, 0x064d, 0x0620, 0x05f4, 0x055c, 0x050c,
	0x0c3f, 0x0601, 0x05a8, 0x0583, 0x055c, 0x0535, 0x04b0, 0x046a
};


const int16_t quantization_scale_88_extended[13*64] = {
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,

	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  4096,
	 8192,  8192,  8192,  8192,  8192,  8192,  4096,  4096,
	 8192,  8192,  8192,  8192,  8192,  4096,  4096,  4096,
	 8192,  8192,  8192,  8192,  4096,  4096,  4096,  4096,
	 8192,  8192,  8192,  4096,  4096,  4096,  4096,  4096,
	 8192,  8192,  4096,  4096,  4096,  4096,  4096,  4096,

	 8192,  8192,  8192,  8192,  8192,  8192,  4096,  4096,
	 8192,  8192,  8192,  8192,  8192,  4096,  4096,  4096,
	 8192,  8192,  8192,  8192,  4096,  4096,  4096,  4096,
	 8192,  8192,  8192,  4096,  4096,  4096,  4096,  4096,
	 8192,  8192,  4096,  4096,  4096,  4096,  4096,  4096,
	 8192,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,

	 8192,  8192,  8192,  4096,  4096,  4096,  4096,  4096,
	 8192,  8192,  4096,  4096,  4096,  4096,  4096,  4096,
	 8192,  4096,  4096,  4096,  4096,  4096,  4096,  2048,
	 4096,  4096,  4096,  4096,  4096,  4096,  2048,  2048,
	 4096,  4096,  4096,  4096,  4096,  2048,  2048,  2048,
	 4096,  4096,  4096,  4096,  2048,  2048,  2048,  2048,
	 4096,  4096,  4096,  2048,  2048,  2048,  2048,  2048,
	 4096,  4096,  2048,  2048,  2048,  2048,  2048,  2048,

	 8192,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,

	 8192,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  2048,
	 4096,  4096,  4096,  4096,  4096,  4096,  2048,  2048,
	 4096,  4096,  4096,  4096,  4096,  2048,  2048,  2048,
	 4096,  4096,  4096,  4096,  2048,  2048,  2048,  2048,
	 4096,  4096,  4096,  2048,  2048,  2048,  2048,  2048,
	 4096,  4096,  2048,  2048,  2048,  2048,  2048,  2048,

	 8192,  4096,  4096,  4096,  4096,  4096,  2048,  2048,
	 4096,  4096,  4096,  4096,  4096,  2048,  2048,  2048,
	 4096,  4096,  4096,  4096,  2048,  2048,  2048,  2048,
	 4096,  4096,  4096,  2048,  2048,  2048,  2048,  2048,
	 4096,  4096,  2048,  2048,  2048,  2048,  2048,  2048,
	 4096,  2048,  2048,  2048,  2048,  2048,  2048,  2048,
	 2048,  2048,  2048,  2048,  2048,  2048,  2048,  2048,
	 2048,  2048,  2048,  2048,  2048,  2048,  2048,  2048,

	 8192,  4096,  4096,  2048,  2048,  2048,  2048,  2048,
	 4096,  4096,  2048,  2048,  2048,  2048,  2048,  2048,
	 4096,  2048,  2048,  2048,  2048,  2048,  2048,  1024,
	 2048,  2048,  2048,  2048,  2048,  2048,  1024,  1024,
	 2048,  2048,  2048,  2048,  2048,  1024,  1024,  1024,
	 2048,  2048,  2048,  2048,  1024,  1024,  1024,  1024,
	 2048,  2048,  2048,  1024,  1024,  1024,  1024,  1024,
	 2048,  2048,  1024,  1024,  1024,  1024,  1024,  1024,

	 8192,  2048,  2048,  2048,  2048,  2048,  1024,  1024,
	 2048,  2048,  2048,  2048,  2048,  1024,  1024,  1024,
	 2048,  2048,  2048,  2048,  1024,  1024,  1024,  1024,
	 2048,  2048,  2048,  1024,  1024,  1024,  1024,  1024,
	 2048,  2048,  1024,  1024,  1024,  1024,  1024,  1024,
	 2048,  1024,  1024,  1024,  1024,  1024,  1024,  1024,
	 1024,  1024,  1024,  1024,  1024,  1024,  1024,  1024,
	 1024,  1024,  1024,  1024,  1024,  1024,  1024,  1024,

	 8192,  2048,  2048,  1024,  1024,  1024,  1024,  1024,
	 2048,  2048,  1024,  1024,  1024,  1024,  1024,  1024,
	 2048,  1024,  1024,  1024,  1024,  1024,  1024,   512,
	 1024,  1024,  1024,  1024,  1024,  1024,   512,   512,
	 1024,  1024,  1024,  1024,  1024,   512,   512,   512,
	 1024,  1024,  1024,  1024,   512,   512,   512,   512,
	 1024,  1024,  1024,   512,   512,   512,   512,   512,
	 1024,  1024,   512,   512,   512,   512,   512,   512,

	 8192,  1024,  1024,  1024,  1024,  1024,   512,   512,
	 1024,  1024,  1024,  1024,  1024,   512,   512,   512,
	 1024,  1024,  1024,  1024,   512,   512,   512,   512,
	 1024,  1024,  1024,   512,   512,   512,   512,   512,
	 1024,  1024,   512,   512,   512,   512,   512,   512,
	 1024,   512,   512,   512,   512,   512,   512,   512,
	  512,   512,   512,   512,   512,   512,   512,   512,
	  512,   512,   512,   512,   512,   512,   512,   512,

	 8192,  1024,  1024,   512,   512,   512,   512,   512,
	 1024,  1024,   512,   512,   512,   512,   512,   512,
	 1024,   512,   512,   512,   512,   512,   512,   256,
	  512,   512,   512,   512,   512,   512,   256,   256,
	  512,   512,   512,   512,   512,   256,   256,   256,
	  512,   512,   512,   512,   256,   256,   256,   256,
	  512,   512,   512,   256,   256,   256,   256,   256,
	  512,   512,   256,   256,   256,   256,   256,   256,

	 8192,   512,   512,   512,   512,   512,   256,   256,
	  512,   512,   512,   512,   512,   256,   256,   256,
	  512,   512,   512,   512,   256,   256,   256,   256,
	  512,   512,   512,   256,   256,   256,   256,   256,
	  512,   512,   256,   256,   256,   256,   256,   256,
	  512,   256,   256,   256,   256,   256,   256,   256,
	  256,   256,   256,   256,   256,   256,   256,   256,
	  256,   256,   256,   256,   256,   256,   256,   256
};


const int16_t quantization_scale_248_extended[13*64] = {
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  8192,

	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  4096,
	 8192,  8192,  8192,  8192,  8192,  8192,  4096,  4096,
	 8192,  8192,  8192,  8192,  8192,  4096,  4096,  4096,
	 8192,  8192,  8192,  8192,  4096,  4096,  4096,  4096,
	 8192,  8192,  8192,  8192,  8192,  8192,  8192,  4096,
	 8192,  8192,  8192,  8192,  8192,  8192,  4096,  4096,
	 8192,  8192,  8192,  8192,  8192,  4096,  4096,  4096,
	 8192,  8192,  8192,  4096,  4096,  4096,  4096,  4096,

	 8192,  8192,  8192,  8192,  8192,  4096,  4096,  4096,
	 8192,  8192,  8192,  4096,  4096,  4096,  4096,  4096,
	 8192,  8192,  4096,  4096,  4096,  4096,  4096,  4096,
	 8192,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 8192,  8192,  8192,  8192,  4096,  4096,  4096,  4096,
	 8192,  8192,  8192,  4096,  4096,  4096,  4096,  4096,
	 8192,  8192,  4096,  4096,  4096,  4096,  4096,  4096,
	 8192,  4096,  4096,  4096,  4096,  4096,  4096,  4096,

	 8192,  8192,  4096,  4096,  4096,  4096,  4096,  2048,
	 8192,  4096,  4096,  4096,  4096,  4096,  2048,  2048,
	 4096,  4096,  4096,  4096,  4096,  2048,  2048,  2048,
	 4096,  4096,  4096,  4096,  2048,  2048,  2048,  2048,
	 8192,  8192,  4096,  4096,  4096,  4096,  4096,  2048,
	 8192,  4096,  4096,  4096,  4096,  4096,  2048,  2048,
	 4096,  4096,  4096,  4096,  4096,  2048,  2048,  2048,
	 4096,  4096,  4096,  2048,  2048,  2048,  2048,  2048,

	 8192,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,

	 8192,  4096,  4096,  4096,  4096,  4096,  4096,  2048,
	 4096,  4096,  4096,  4096,  4096,  4096,  2048,  2048,
	 4096,  4096,  4096,  4096,  4096,  2048,  2048,  2048,
	 4096,  4096,  4096,  4096,  2048,  2048,  2048,  2048,
	 4096,  4096,  4096,  4096,  4096,  4096,  4096,  2048,
	 4096,  4096,  4096,  4096,  4096,  4096,  2048,  2048,
	 4096,  4096,  4096,  4096,  4096,  2048,  2048,  2048,
	 4096,  4096,  4096,  2048,  2048,  2048,  2048,  2048,

	 8192,  4096,  4096,  4096,  4096,  2048,  2048,  2048,
	 4096,  4096,  4096,  2048,  2048,  2048,  2048,  2048,
	 4096,  4096,  2048,  2048,  2048,  2048,  2048,  2048,
	 4096,  2048,  2048,  2048,  2048,  2048,  2048,  2048,
	 4096,  4096,  4096,  4096,  2048,  2048,  2048,  2048,
	 4096,  4096,  4096,  2048,  2048,  2048,  2048,  2048,
	 4096,  4096,  2048,  2048,  2048,  2048,  2048,  2048,
	 4096,  2048,  2048,  2048,  2048,  2048,  2048,  2048,

	 8192,  4096,  2048,  2048,  2048,  2048,  2048,  1024,
	 4096,  2048,  2048,  2048,  2048,  2048,  1024,  1024,
	 2048,  2048,  2048,  2048,  2048,  1024,  1024,  1024,
	 2048,  2048,  2048,  2048,  1024,  1024,  1024,  1024,
	 4096,  4096,  2048,  2048,  2048,  2048,  2048,  1024,
	 4096,  2048,  2048,  2048,  2048,  2048,  1024,  1024,
	 2048,  2048,  2048,  2048,  2048,  1024,  1024,  1024,
	 2048,  2048,  2048,  1024,  1024,  1024,  1024,  1024,

	 8192,  2048,  2048,  2048,  2048,  1024,  1024,  1024,
	 2048,  2048,  2048,  1024,  1024,  1024,  1024,  1024,
	 2048,  2048,  1024,  1024,  1024,  1024,  1024,  1024,
	 2048,  1024,  1024,  1024,  1024,  1024,  1024,  1024,
	 2048,  2048,  2048,  2048,  1024,  1024,  1024,  1024,
	 2048,  2048,  2048,  1024,  1024,  1024,  1024,  1024,
	 2048,  2048,  1024,  1024,  1024,  1024,  1024,  1024,
	 2048,  1024,  1024,  1024,  1024,  1024,  1024,  1024,

	 8192,  2048,  1024,  1024,  1024,  1024,  1024,   512,
	 2048,  1024,  1024,  1024,  1024,  1024,   512,   512,
	 1024,  1024,  1024,  1024,  1024,   512,   512,   512,
	 1024,  1024,  1024,  1024,   512,   512,   512,   512,
	 2048,  2048,  1024,  1024,  1024,  1024,  1024,   512,
	 2048,  1024,  1024,  1024,  1024,  1024,   512,   512,
	 1024,  1024,  1024,  1024,  1024,   512,   512,   512,
	 1024,  1024,  1024,   512,   512,   512,   512,   512,

	 8192,  1024,  1024,  1024,  1024,   512,   512,   512,
	 1024,  1024,  1024,   512,   512,   512,   512,   512,
	 1024,  1024,   512,   512,   512,   512,   512,   512,
	 1024,   512,   512,   512,   512,   512,   512,   512,
	 1024,  1024,  1024,  1024,   512,   512,   512,   512,
	 1024,  1024,  1024,   512,   512,   512,   512,   512,
	 1024,  1024,   512,   512,   512,   512,   512,   512,
	 1024,   512,   512,   512,   512,   512,   512,   512,

	 8192,  1024,   512,   512,   512,   512,   512,   256,
	 1024,   512,   512,   512,   512,   512,   256,   256,
	  512,   512,   512,   512,   512,   256,   256,   256,
	  512,   512,   512,   512,   256,   256,   256,   256,
	 1024,  1024,   512,   512,   512,   512,   512,   256,
	 1024,   512,   512,   512,   512,   512,   256,   256,
	  512,   512,   512,   512,   512,   256,   256,   256,
	  512,   512,   512,   256,   256,   256,   256,   256,

	 8192,   512,   512,   512,   512,   256,   256,   256,
	  512,   512,   512,   256,   256,   256,   256,   256,
	  512,   512,   256,   256,   256,   256,   256,   256,
	  512,   256,   256,   256,   256,   256,   256,   256,
	  512,   512,   512,   512,   256,   256,   256,   256,
	  512,   512,   512,   256,   256,   256,   256,   256,
	  512,   512,   256,   256,   256,   256,   256,   256,
	  512,   256,   256,   256,   256,   256,   256,   256
};



int16_t core_positive_negative[128*4] = {
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,

	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,
	      0,       0,       0,       0,       0,       0,       0,       0,

		0, 0, 0, 256, 256, 256, 256, 256,
		0, 0, 256, 256, 256, 256, 256, 256,
		0, 256, 256, 256, 256, 256, 512, 512,
		256, 256, 256, 256, 256, 256, 512, 512,
		0, 0, 256, 256, 256, 256, 512, 512,
		0, 256, 256, 256, 256, 256, 512, 512,
		256, 256, 256, 256, 256, 512, 512, 512,
		256, 256, 512, 512, 512, 512, 512, 512,

		0, 0, -0, -256, -256, -256, -256, -256,
		0, 0, -256, -256, -256, -256, -256, -256,
		-0, -256, -256, -256, -256, -256, -512, -512,
		-256, -256, -256, -256, -256, -256, -512, -512,
		-0, -0, -256, -256, -256, -256, -512, -512,
		-0, -256, -256, -256, -256, -256, -512, -512,
		-256, -256, -256, -256, -256, -512, -512, -512,
		-256, -256, -512, -512, -512, -512, -512, -512,

		0, 0, 0, 256, 512, 512, 512, 512,
		0, 0, 256, 512, 512, 512, 512, 512,
		0, 256, 512, 512, 512, 512, 512, 4096,
		256, 512, 512, 512, 512, 512, 512, 4096,
		0, 0, 256, 512, 512, 512, 512, 4096,
		0, 256, 512, 512, 512, 512, 4096, 4096,
		256, 512, 512, 512, 512, 4096, 4096, 4096,
		512, 512, 512, 512, 4096, 4096, 4096, 4096,

		 0, -0, -0, -256, -512, -512, -512, -512,
		-0, -0, -256, -512, -512, -512, -512, -512,
		-0, -256, -512, -512, -512, -512, -512, -4096,
		-256, -512, -512, -512, -512, -512, -512, -4096,
		-0, -0, -256, -512, -512, -512, -512, -4096,
		-0, -256, -512, -512, -512, -512, -4096, -4096,
		-256, -512, -512, -512, -512, -4096, -4096, -4096,
		-512, -512, -512, -512, -4096, -4096, -4096, -4096,


	      0,       0,       256,      16344,    16344,   10213,   16344,   16383,
	      0,       0,       256,      16344,    16344,   10213,   16344,   16383,
	      256,       256,       256,      16344,    16344,   10214,   16344,   16383,
	     256,      256,      256,     16344,    16344,   10249,   16344,   16383,
	   0,    1631,    1632,    16344,    16344,   10827,   16348,   16383,
	  10213,   10213,   10214,   10249,   10827,   14059,   16368,   16383,
	  16344,   16344,   16344,   16344,   16348,   16368,   16383,   16383,
	  16383,   16383,   16383,   16383,   16383,   16383,   16383,   16383,

	      0,       0,      -256,     -16344,   -16344,  -10213,  -16344,  -16383,
	      0,       0,      -256,     -16344,   -16344,  -10213,  -16344,  -16383,
	     -256,      -256,      -256,     -16344,   -16344,  -10214,  -16344,  -16383,
	    -256,     -256,     -256,    -16344,   -16344,  -10249,  -16344,  -16383,
	  -0,   -1631,   -1632,   -16344,   -16344,  -10827,  -16348,  -16383,
	 -10213,  -10213,  -10214,  -10249,  -10827,  -14059,  -16368,  -16383,
	 -16344,  -16344,  -16344,  -16344,  -16348,  -16368,  -16383,  -16383,
	 -16383,  -16383,  -16383,  -16383,  -16383,  -16383,  -16383,  -16383

};

