%******************************************************************************
%*                                                                            *
%*  Cedocida DV-Codec                                                         *
%*                                                                            *
%*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              *
%*  Project start: 15.12.2003                                                 *
%*  Last change  : 08.05.2005                                                 *
%*                                                                            *
%******************************************************************************
%*                                                                            *
%*  This program is free software; you can redistribute it and/or modify      *
%*  it under the terms of the GNU General Public License as published by      *
%*  the Free Software Foundation; either version 2 of the License, or         *
%*  (at your option) any later version.                                       *
%*                                                                            *
%*  This program is distributed in the hope that it will be useful,           *
%*  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
%*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
%*  GNU General Public License for more details.                              *
%*                                                                            *
%*  You should have received a copy of the GNU General Public License         *
%*  along with this program; if not, write to the Free Software               *
%*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
%*                                                                            *
%******************************************************************************

OUTPUT_FILENAME = '_constants.h';
OUTPUT_FILENAME_1 = '_encode_tables.h';
OUTPUT_FILENAME_2 = 'decode_tables.h';
OUTPUT_FILENAME_3 = 'vlc.h';
OUTPUT_FILENAME_4 = '_dv_spec.h';

MAX_INT16 = 2^15-1;
MIN_INT16 = -2^15;
warning off;


if (exist( 'OUTPUT_FILENAME' )==1)
   fid = fopen( OUTPUT_FILENAME, 'w' );
else
   fid = 1;
end

if (exist( 'OUTPUT_FILENAME_1' )==1)
   fid1 = fopen( OUTPUT_FILENAME_1, 'w' );
else
   fid1 = 1;
end

if (exist( 'OUTPUT_FILENAME_2' )==1)
   fid2 = fopen( OUTPUT_FILENAME_2, 'w' );
else
   fid2 = 1;
end

if (exist( 'OUTPUT_FILENAME_3' )==1)
   fid3 = fopen( OUTPUT_FILENAME_3, 'w' );
else
   fid3 = 1;
end

if (exist( 'OUTPUT_FILENAME_4' )==1)
   fid4 = fopen( OUTPUT_FILENAME_4, 'w' );
else
   fid4 = 1;
end


dv_spec;

%*******************************************************************************
%* scan_order                                                                  *
%*******************************************************************************

output_order_88_inv = zeros(1,64);
for i=[1:64]
   output_order_88_inv( output_order_88(i) ) = i;
end

output_order_248_inv = zeros(1,64);
for i=[1:64]
   output_order_248_inv( output_order_248(i) ) = i;
end

fprintf(fid3, '\n');
fprintf(fid3, 'const uint8_t scan_order_88[64] = {\n');
for i=1:8,
   fprintf(fid3, '\t%3i', output_order_88_inv((i-1)*8+[1])-1 );
   fprintf(fid3, ',%3i', output_order_88_inv((i-1)*8+[2:8])-1 );
   fprintf(fid3, ',\n');
end
fprintf(fid3, '};\n\n\n');

fprintf(fid3, 'const uint8_t scan_order_248[64] = {\n');
for i=1:8,
   fprintf(fid3, '\t%3i', output_order_248_inv((i-1)*8+[1])-1 );
   fprintf(fid3, ',%3i', output_order_248_inv((i-1)*8+[2:8])-1 );
   fprintf(fid3, ',\n');
end
fprintf(fid3, '};\n\n\n');



%*******************************************************************************
%* weigthing and quantization tables                                           *
%*******************************************************************************

quantization_code_table = [ ...	%adress = c1c0*16 + QNO
      5, 5, 4, 4, 3, 3, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, ...
      7, 6, 6, 5, 5, 4, 4, 3, 3, 2, 2, 1, 0, 0, 0, 0, ...
      8, 8, 7, 7, 6, 6, 5, 5, 4, 4, 3, 3, 2, 2, 1, 0, ...
      8, 7, 7, 6, 6, 5, 5, 4, 4, 3, 3, 2, 2, 1, 0, 0 ...
      ];
   
% see IEC 61834-2, table 23
quantization_step_table = [ ...
      1 1 1 1; ...
      1 1 1 2; ...
      1 1 2 2; ...
      1 2 2 4; ...
      2 2 4 4; ...
      2 4 4 8; ...
      4 4 8 8; ...
      4 8 8 16; ...
      8 8 16 16];

quantization_code_table_extended = [ ...	%adress = c1c0*16 + QNO
      7, 7, 6, 6, 3, 3, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, ...
      9, 8, 8, 7, 7, 6, 6, 3, 3, 2, 2, 1, 0, 0, 0, 0, ...
      10,10,9, 9, 8, 8, 7, 7, 6, 6, 3, 3, 2, 2, 1, 0, ...
   	12,11,11,10,10,9, 9, 8, 8, 7, 7, 6, 6, 5, 4, 4 ...
      ];
   
quantization_step_table_extended = [ ...
      1 1 1 1; ...	%0
      1 1 1 2; ...	%1
      1 1 2 2; ...	%2
      1 2 2 4; ...	%3
    	2 2 2 2; ...	%4
      2 2 2 4; ...	%5
      2 2 4 4; ...	%6
      2 4 4 8; ...	%7
      4 4 8 8; ...	%8
      4 8 8 16; ...	%9
      8 8 16 16; ... %10
      8 16 16 32; ...	%11
      16 16 32 32; ...	%12
   ];


%***************************************
%* quantization_code_table             *
%***************************************
fprintf(fid4, '\n');
fprintf(fid4, '//q = quantization_code_table[(c1c0<<4)+QNO], QNO = 0..15, c1c0 = 0..3\n');
fprintf(fid4, 'const uint32_t quantization_code_table[16*4] = {\n');
for n=1:4,
   fprintf(fid4, '\t%2i', quantization_code_table( (n-1)*16+[1]) );
   fprintf(fid4, ', %2i', quantization_code_table( (n-1)*16+[2:16]) );
   if (n~=4) fprintf(fid4, ',\n'); end
end
fprintf(fid4, '\n};\n\n\n');

%***************************************
%* quantization_code_table_extended    *
%***************************************
fprintf(fid4, '//q = quantization_code_table[(c1c0<<4)+QNO], QNO = 0..15, c1c0 = 0..3\n');
fprintf(fid4, 'const uint32_t quantization_code_table_extended[16*4] = {\n');
for n=1:4,
   fprintf(fid4, '\t%2i', quantization_code_table_extended( (n-1)*16+[1]) );
   fprintf(fid4, ', %2i', quantization_code_table_extended( (n-1)*16+[2:16]) );
   if (n~=4) fprintf(fid4, ',\n'); end
end
fprintf(fid4, '\n};\n\n\n');


      
Q_88 = zeros(9,64);
for n=1:9,
   for i=1:64,
      Q_88(n,i) = quantization_step_table(n, area_number_88(i)+1);
   end
   Q_88(n,1) = 1;
end

Q_248 = zeros(9,64);
for n=1:9,
   for i=1:64,
      Q_248(n,i) = quantization_step_table(n, area_number_248(i)+1);
   end
   Q_248(n,1) = 1;
end

Q_88_extended = zeros(13,64);
for n=1:13,
   for i=1:64,
      Q_88_extended(n,i) = quantization_step_table_extended(n, area_number_88(i)+1);
   end
   Q_88_extended(n,1) = 1;
end

Q_248_extended = zeros(13,64);
for n=1:13,
   for i=1:64,
      Q_248_extended(n,i) = quantization_step_table_extended(n, area_number_248(i)+1);
   end
   Q_248_extended(n,1) = 1;
end

%***************************************
%* quantization_step_88_extended       *
%***************************************

fprintf(fid2, '\n// weight and quantize tables\n\n');
fprintf(fid2, 'const int16_t quantization_step_88_extended[13*64] = {\n');
N_rows=13; N_cols=8;
for n=1:N_rows,
   for i=1:N_cols,
      fprintf(fid2, '\t%2i', Q_88_extended(n,(i-1)*N_cols+[1]) );
      fprintf(fid2, ', %2i', Q_88_extended(n,(i-1)*N_cols+[2:8]) );
   	if ((n~=N_rows) | (i~=N_cols)) fprintf(fid2, ',\n'); end
   end
   fprintf(fid2, '\n');
end
fprintf(fid2, '};\n\n\n');

%***************************************
%* quantization_step_248_extended      *
%***************************************
fprintf(fid2, 'const int16_t quantization_step_248_extended[13*64] = {\n');
N_rows=13; N_cols=8;
for n=1:N_rows,
   for i=1:N_cols,
      fprintf(fid2, '\t%2i', Q_248_extended(n,(i-1)*N_cols+[1]) );
      fprintf(fid2, ', %2i', Q_248_extended(n,(i-1)*N_cols+[2:8]) );
   	if ((n~=N_rows) | (i~=N_cols)) fprintf(fid2, ',\n'); end
   end
   fprintf(fid2, '\n');
end
fprintf(fid2, '};\n\n\n');



%***************************************
%* quantization_scale_88_extended      *
%***************************************
fprintf(fid1, 'const int16_t quantization_scale_88_extended[13*64] = {\n');
N_rows=13; N_cols=8;
for n=1:N_rows,
   for i=1:N_cols,
      fprintf(fid1, '\t%5i', 2^13./Q_88_extended(n,(i-1)*N_cols+[1]) );
      fprintf(fid1, ', %5i', 2^13./Q_88_extended(n,(i-1)*N_cols+[2:8]) );
   	if ((n~=N_rows) | (i~=N_cols)) fprintf(fid1, ',\n'); end
   end
   fprintf(fid1, '\n');
end
fprintf(fid1, '};\n\n\n');

%***************************************
%* quantization_scale_248_extended      *
%***************************************
fprintf(fid1, 'const int16_t quantization_scale_248_extended[13*64] = {\n');
N_rows=13; N_cols=8;
for n=1:N_rows,
   for i=1:N_cols,
      fprintf(fid1, '\t%5i', 2^13./Q_248_extended(n,(i-1)*N_cols+[1]) );
      fprintf(fid1, ', %5i', 2^13./Q_248_extended(n,(i-1)*N_cols+[2:8]) );
   	if ((n~=N_rows) | (i~=N_cols)) fprintf(fid1, ',\n'); end
   end
   fprintf(fid1, '\n');
end
fprintf(fid1, '};\n\n\n');



W_88_inv_16bit = floor( 1./W_88/8*2^16 + 0.5 );
if (sum(sum(( (W_88_inv_16bit>MAX_INT16)  ))))
   warning('W88_inv too large');
end
W_88_inv_16bit = min( max( W_88_inv_16bit, MIN_INT16 ), MAX_INT16 );

W_248_inv_16bit = floor( 1./W_248/8*2^16 + 0.5 );
if (sum(sum(( (W_248_inv_16bit>MAX_INT16)  ))))
   warning('W248_inv too large');
end
W_248_inv_16bit = min( max( W_248_inv_16bit, MIN_INT16 ), MAX_INT16 );

%***************************************
%* W_88_inv_16bit                      *
%***************************************
fprintf(fid2, 'const int16_t W_88_inv_16bit[64] = {\n');
N_cols=8;
for i=1:N_cols,
   fprintf(fid2, '\t%6i', W_88_inv_16bit((i-1)*N_cols+[1]) );
   fprintf(fid2, ', %6i', W_88_inv_16bit((i-1)*N_cols+[2:8]) );
   if (i~=N_cols) fprintf(fid2, ',\n'); end
end
fprintf(fid2, '\n');
fprintf(fid2, '};\n\n\n');

%***************************************
%* W_248_inv_16bit                     *
%***************************************
fprintf(fid2, 'const int16_t W_248_inv_16bit[64] = {\n');
N_cols=8;
for i=1:N_cols,
   fprintf(fid2, '\t%6i', W_248_inv_16bit((i-1)*N_cols+[1]) );
   fprintf(fid2, ', %6i', W_248_inv_16bit((i-1)*N_cols+[2:8]) );
   if (i~=N_cols) fprintf(fid2, ',\n'); end
end
fprintf(fid2, '\n');
fprintf(fid2, '};\n\n\n');



W_88_16bit = floor( W_88*2^16 + 0.5 );
if (sum(sum(( (W_88_16bit>MAX_INT16)  ))))
   warning('W88 too large');
end
W_88_16bit = min( max( W_88_16bit, MIN_INT16 ), MAX_INT16 );

W_248_16bit = floor( W_248*2^16 + 0.5 );
if (sum(sum(( (W_248_16bit>MAX_INT16)  ))))
   warning('W248 too large');
end
W_248_16bit = min( max( W_248_16bit, MIN_INT16 ), MAX_INT16 );

%***************************************
%* W_88_16bit                          *
%***************************************
fprintf(fid, 'const int16_t W_88_16bit[64] = {\n');
N_cols=8;
for i=1:N_cols,
   fprintf(fid, '\t%6i', W_88_16bit((i-1)*N_cols+[1]) );
   fprintf(fid, ', %6i', W_88_16bit((i-1)*N_cols+[2:8]) );
   if (i~=N_cols) fprintf(fid, ',\n'); end
end
fprintf(fid, '\n');
fprintf(fid, '};\n\n\n');

%***************************************
%* W_248_16bit                         *
%***************************************
fprintf(fid, 'const int16_t W_248_16bit[64] = {\n');
N_cols=8;
for i=1:N_cols,
   fprintf(fid, '\t%6i', W_248_16bit((i-1)*N_cols+[1]) );
   fprintf(fid, ', %6i', W_248_16bit((i-1)*N_cols+[2:8]) );
   if (i~=N_cols) fprintf(fid, ',\n'); end
end
fprintf(fid, '\n');
fprintf(fid, '};\n\n\n');



WQ_88 = (ones(9,1)*W_88)./Q_88;
WQ_248 = (ones(9,1)*W_248)./Q_248;

WQ_88_16bit = floor( WQ_88*2^16 + 0.5 );
if (sum(sum(( (WQ_88_16bit>MAX_INT16)  ))))
   warning('WQ88 too large');
end
WQ_88_16bit = min( max( WQ_88_16bit, MIN_INT16 ), MAX_INT16 );

WQ_248_16bit = floor( WQ_248*2^16 + 0.5 );
if (sum(sum(( (WQ_248_16bit>MAX_INT16)  ))))
   warning('WQ248 too large');
end
WQ_248_16bit = min( max( WQ_248_16bit, MIN_INT16 ), MAX_INT16 );

%***************************************
%* WQ_88                               *
%***************************************

fprintf(fid1, '\n// weight and quantize tables\n');
fprintf(fid1, 'const int16_t WQ_88[9*64] = {\n');
for n=1:9,
   for i=1:8,
      fprintf(fid1, '\t0x%04x', WQ_88_16bit(n,(i-1)*8+[1]) );
      fprintf(fid1, ', 0x%04x', WQ_88_16bit(n,(i-1)*8+[2:8]) );
   	if ((n~=9) | (i~=8)) fprintf(fid1, ',\n'); end
   end
   fprintf(fid1, '\n');
end
fprintf(fid1, '};\n\n\n');

%***************************************
%* WQ_248                              *
%***************************************
fprintf(fid1, 'const int16_t WQ_248[9*64] = {\n');
for n=1:9,
   for i=1:8,
      fprintf(fid1, '\t0x%04x', WQ_248_16bit(n,(i-1)*8+[1]) );
      fprintf(fid1, ', 0x%04x', WQ_248_16bit(n,(i-1)*8+[2:8]) );
   	if ((n~=9) | (i~=8)) fprintf(fid1, ',\n'); end
   end
   fprintf(fid1, '\n');
end
fprintf(fid1, '};\n\n\n');







WQ_88_extended = (ones(13,1)*W_88)./Q_88_extended;
WQ_248_extended = (ones(13,1)*W_248)./Q_248_extended;

WQ_88_extended_16bit = floor( WQ_88_extended*2^16 + 0.5 );
if (sum(sum(( (WQ_88_extended_16bit>MAX_INT16)  ))))
   warning('WQ88_extended too large');
end
WQ_88_extended_16bit = min( max( WQ_88_extended_16bit, MIN_INT16 ), MAX_INT16 );

WQ_248_extended_16bit = floor( WQ_248_extended*2^16 + 0.5 );
if (sum(sum(( (WQ_248_extended_16bit>MAX_INT16)  ))))
   warning('WQ248_extended too large');
end
WQ_248_extended_16bit = min( max( WQ_248_extended_16bit, MIN_INT16 ), MAX_INT16 );


fprintf(fid, 'const int16_t WQ_88_extended[13*64] = {\n');
for n=1:13,
   for i=1:8,
      fprintf(fid, '\t0x%04x', WQ_88_extended_16bit(n,(i-1)*8+[1]) );
      fprintf(fid, ', 0x%04x', WQ_88_extended_16bit(n,(i-1)*8+[2:8]) );
   	if ((n~=13) | (i~=8)) fprintf(fid, ',\n'); end
   end
   fprintf(fid, '\n');
end
fprintf(fid, '};\n\n\n');

fprintf(fid, 'const int16_t WQ_248_extended[13*64] = {\n');
for n=1:13,
   for i=1:8,
      fprintf(fid, '\t0x%04x', WQ_248_extended_16bit(n,(i-1)*8+[1]) );
      fprintf(fid, ', 0x%04x', WQ_248_extended_16bit(n,(i-1)*8+[2:8]) );
   	if ((n~=13) | (i~=8)) fprintf(fid, ',\n'); end
   end
   fprintf(fid, '\n');
end
fprintf(fid, '};\n\n\n');




%*******************************************************************************
%* DCT-2-4-8 coefficient tables                                                *
%*******************************************************************************

KC_U_16bit = max( min( floor( KC_U*2^15 + 0.5 ), MAX_INT16 ), MIN_INT16 );
KC_H_16bit = max( min( floor( KC_H*2^15 + 0.5 ), MAX_INT16 ), MIN_INT16 );

fprintf(fid, 'const int16_t KC_H[8*8] = {\n');
for i=1:8,
   fprintf(fid, '\t%6i', KC_H_16bit((i-1)*8+[1]) );
   fprintf(fid, ', %6i', KC_H_16bit((i-1)*8+[2:8]) );
   if (i~=8) fprintf(fid, ',\n'); end
end
fprintf(fid, '\n');
fprintf(fid, '};\n\n\n');

fprintf(fid, 'const int16_t KC_U[4*4] = {\n');
for i=1:4,
   fprintf(fid, '\t%6i', KC_U_16bit((i-1)*4+[1]) );
   fprintf(fid, ', %6i', KC_U_16bit((i-1)*4+[2:4]) );
   if (i~=4) fprintf(fid, ',\n'); end
end
fprintf(fid, '\n');
fprintf(fid, '};\n\n\n');




fclose('all');

      