%******************************************************************************
%*                                                                            *
%*  Cedocida DV-Codec                                                         *
%*                                                                            *
%*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              *
%*  Project start: 15.12.2003                                                 *
%*  Last change  : 08.05.2005                                                 *
%*                                                                            *
%******************************************************************************
%*                                                                            *
%*  This program is free software; you can redistribute it and/or modify      *
%*  it under the terms of the GNU General Public License as published by      *
%*  the Free Software Foundation; either version 2 of the License, or         *
%*  (at your option) any later version.                                       *
%*                                                                            *
%*  This program is distributed in the hope that it will be useful,           *
%*  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
%*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
%*  GNU General Public License for more details.                              *
%*                                                                            *
%*  You should have received a copy of the GNU General Public License         *
%*  along with this program; if not, write to the Free Software               *
%*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
%*                                                                            *
%******************************************************************************

%*******************************************************************************
%* IEC 61834-2 / Section 7.5.2: Weigting factors (after DCT processing)        *
%*******************************************************************************

CS = cos([1:7]*pi/16);

w = zeros(1,8);
w(1)=1;
w(2)=CS(4)/(4*CS(7)*CS(2));
w(3)=CS(4)/(2*CS(6));
w(4)=1/(2*CS(5));
w(5)=7/8;
w(6)=CS(4)/CS(3);
w(7)=CS(4)/CS(2);
w(8)=CS(4)/CS(1);

W_88 = zeros(8,8);
for(h=1:8),
   for(v=1:8),
      if( (h==1) & (v==1) )
         W_88(h,v) = 1/4;
      else
         W_88(h,v) = w(h)*w(v)/2;
      end
   end
end
W_88 = reshape( W_88, 1, 64 );

W_248 = zeros(8,8);
for(h=1:8),
   for(v=1:8),
      if( (h==1) & (v==1) )
         W_248(h,v) = 1/4;
      elseif ( v<5 )
         W_248(h,v) = w(h)*w(2*(v-1)+1)/2;
      else
         W_248(h,v) = w(h)*w(2*(v-5)+1)/2;
      end
   end
end
W_248 = reshape( W_248, 1, 64 );


%*******************************************************************************
%* IEC 61834-2 / Picture 35: The output order of a weighted DCT block          *
%*******************************************************************************

output_order_88 = [ ....
      1 2 6 7 15 16 28 29 ...
      3 5 8 14 17 27 30 43 ...
      4 9 13 18 26 31 42 44 ...
      10 12 19 25 32 41 45 54 ...
      11 20 24 33 40 46 53 55 ...
      21 23 34 39 47 52 56 61 ...
      22 35 38 48 51 57 60 62 ...
      36 37 49 50 58 59 63 64 ];

output_order_248 = [ ...
      1 3 7 19 21 35 37 51 ...
      5 9 17 23 33 39 49 53 ...
      11 15 25 31 41 47 55 61 ...
      13 27 29 43 45 57 59 63 ...
      2 4 8 20 22 36 38 52 ...
      6 10 18 24 34 40 50 54 ...
      12 16 26 32 42 48 56 62 ...
      14 28 30 44 46 58 60 64 ...
];


%*******************************************************************************
%* IEC 61834-2 / Picture 36: Area numbers                                      *
%*******************************************************************************

area_number_88 = ...
	 [ 0 0 0 1 1 1 2 2 ...
      0 0 1 1 1 2 2 2 ...
      0 1 1 1 2 2 2 3 ...
      1 1 1 2 2 2 3 3 ...
      1 1 2 2 2 3 3 3 ...
      1 2 2 2 3 3 3 3 ...
      2 2 2 3 3 3 3 3 ...
      2 2 3 3 3 3 3 3 ];

area_number_248 = [ ...
   	0 0 1 1 1 2 2 3 ...
      0 1 1 2 2 2 3 3 ...
      1 1 2 2 2 3 3 3 ...
      1 2 2 2 3 3 3 3 ...
      0 0 1 1 2 2 2 3 ...
      0 1 1 2 2 2 3 3 ...
      1 1 2 2 2 3 3 3 ...
      1 2 2 3 3 3 3 3 ];


%*******************************************************************************
%* IEC 61834-2 / Section 7.5.1, 2-4-8-DCT-Modus: KC = ...                      *
%*******************************************************************************

% KC = KC_U*KC_H
z = [0:3]; u=[0:3]';
KC_U = cos(pi*u*(2*z+1)/8);
KC_U(1,:) = KC_U(1,:) / sqrt(2);

x = [0:7]; h=[0:7]';
KC_H = cos(pi*h*(2*x+1)/16);
KC_H(1,:) = KC_H(1,:) / sqrt(2);

