%******************************************************************************
%*                                                                            *
%*  Cedocida DV-Codec                                                         *
%*                                                                            *
%*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              *
%*  Project start: 15.12.2003                                                 *
%*  Last change  : 08.05.2005                                                 *
%*                                                                            *
%******************************************************************************
%*                                                                            *
%*  This program is free software; you can redistribute it and/or modify      *
%*  it under the terms of the GNU General Public License as published by      *
%*  the Free Software Foundation; either version 2 of the License, or         *
%*  (at your option) any later version.                                       *
%*                                                                            *
%*  This program is distributed in the hope that it will be useful,           *
%*  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
%*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
%*  GNU General Public License for more details.                              *
%*                                                                            *
%*  You should have received a copy of the GNU General Public License         *
%*  along with this program; if not, write to the Free Software               *
%*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
%*                                                                            *
%******************************************************************************

vlc_code_table;

N = length(vlc_table);


fid=1;

%table1
fprintf(fid,'// run=0..61, amp=0, sign=0 (code and length with sign!)\n');
amp=0;
k=0;
for run=[0:61],
   k=k+1;
   [code, len] = get_code( run, amp, vlc_table, run_table, amp_table );
   if (amp>0)
      code=code*2;
      len=len+1;
   end
   
   if (k==1) fprintf(fid,'\t'); end
   fprintf(fid,'{ 0x%04x, %2i }, ', code, len);
   if (k==4) fprintf(fid,'\n'); k=0; end
end
fprintf(fid, '\n\n');


% table2
fprintf(fid,'// run=0, amp=0..255, sign=0 (code and length with sign!)\n');
run=0;
k=0;
for amp=[0:255],
   k=k+1;
   [code, len] = get_code( run, amp, vlc_table, run_table, amp_table );
   if (amp>0)
      code=code*2;
      len=len+1;
   end
   
   if (k==1) fprintf(fid,'\t'); end
   fprintf(fid,'{ 0x%04x, %2i }, ', code, len);
   if (k==4) fprintf(fid,'\n'); k=0; end
end
fprintf(fid, '\n\n');


%table3
fprintf(fid,'// run=1..4, amp=1..17, sign=0 (code and length with sign!)');
for run=[1:4],
   k=0;
	fprintf(fid,'\n// run=%2i\n',run);
   for amp=[1:17],
   k=k+1;
   [code, len] = get_code( run, amp, vlc_table, run_table, amp_table );
   if (amp>0)
      code=code*2;
      len=len+1;
   end
   
   if (k==1) fprintf(fid,'\t'); end
   fprintf(fid,'{ 0x%08x, %2i }, ', code, len);
   if (k==4) fprintf(fid,'\n'); k=0; end
   end
end
fprintf(fid, '\n\n');


%table4
fprintf(fid,'// run=5..14, amp=1..3, sign=0 (code and length with sign!)');


for run=[5:14],
   k=0;
	fprintf(fid,'\n// run=%2i\n',run);
   for amp=[1:3],
   k=k+1;
   [code, len] = get_code( run, amp, vlc_table, run_table, amp_table );
   if (amp>0)
      code=code*2;
      len=len+1;
   end

   if (k==1) fprintf(fid,'\t'); end
   fprintf(fid,'{ 0x%08x, %2i }, ', code, len);
   if (k==4) fprintf(fid,'\n'); k=0; end
   end
end
fprintf(fid, '\n\n');





